osmo-gmr: TCH3 channel coding

osmo-gmr 0.2.104-2b98 Osmocom GMR-1

Files | Functions
TCH3 channel coding
GMR-1 Layer 1 library » Channel coder / decoders

## Files
file | tch3.h
| Osmocom GMR-1 TCH3 channel coding header.
file | tch3.c
| Osmocom GMR-1 TCH3 channel coding implementation.

## Functions
void | gmr1_tch3_encode (ubit_t *bits_e, const uint8_t *frame0, const uint8_t *frame1, const ubit_t *bits_s, const ubit_t *ciph, int m)
| Stateless GMR-1 TCH3 channel coder. More...
void | gmr1_tch3_decode (uint8_t *frame0, uint8_t *frame1, ubit_t *bits_s, const sbit_t *bits_e, const ubit_t *ciph, int m, int *conv0_rv, int *conv1_rv)
| Stateless GMR-1 TCH3 channel decoder. More...

## Detailed Description

## Function Documentation

## ◆ gmr1_tch3_decode()

void gmr1_tch3_decode | ( | uint8_t * | frame0,
|  | uint8_t * | frame1,
|  | ubit_t * | bits_s,
|  | const sbit_t * | bits_e,
|  | const ubit_t * | ciph,
|  | int | m,
|  | int * | conv0_rv,
|  | int * | conv1_rv
| ) |  |

Stateless GMR-1 TCH3 channel decoder.

Parameters

  [out] | frame0 | 1st speech frame (10 byte / 80 bits, msb first)
  [out] | frame1 | 2nd speech frame (10 byte / 80 bits, msb first)
  [out] | bits_s | 4 status bits that were demultiplexed
  [in] | bits_e | 212 softbits demodulated from a burst
  [in] | ciph | 208 bits of cipher stream (can be NULL)
  [in] | m | Multiplexing mode (0 or 1)
  [out] | conv0_rv | Return of the conv. decode of frame 0 (can be NULL)
  [out] | conv1_rv | Return of the conv. decode of frame 1 (can be NULL)

Returns
  0 if CRC check pass, any other value for fail.

References gmr1_scramble_sbit(), and osmo_conv_decode().

## ◆ gmr1_tch3_encode()

void gmr1_tch3_encode | ( | ubit_t * | bits_e,
|  | const uint8_t * | frame0,
|  | const uint8_t * | frame1,
|  | const ubit_t * | bits_s,
|  | const ubit_t * | ciph,
|  | int | m
| ) |  |

Stateless GMR-1 TCH3 channel coder.

Parameters

  [out] | bits_e | 212 encoded bits to be mapped on a burst
  [in] | frame0 | 1st speech frame (10 byte / 80 bits, msb first)
  [in] | frame1 | 2nd speech frame (10 byte / 80 bits, msb first)
  [in] | bits_s | 4 status bits to be multiplexed
  [in] | ciph | 208 bits of cipher stream (can be NULL)
  [in] | m | Multiplexing mode (0 or 1)

References osmo_conv_encode(), and osmo_pbit2ubit().